Statistics
518
1
0
23d
Badges
Dependencies

Presenter Mapping

Build Status Coverage Status Downloads this Month Latest stable

Installation

Via Composer:

$ composer require nepada/presenter-mapping

Register the extension in config.neon:

extensions:
    - Nepada\Bridges\PresenterMappingDI\PresenterMappingExtension

Usage

The extension replaces standard PresenterFactory provided by ApplicationExtension and adds extended support for presenter mapping. The new presenter mapping system is fully compatible with simple mapping from Nette.

Submodule mapping

Nette supports mapping based only on the root module name, this package adds support for separate mapping for submodules. You can define different mapping for submodule Foo:Bar and it will take precendence over the mapping defined for Foo and * respectively.

Example:

application:
    mapping:
        '*': ['App', 'Module\*', 'Presenter\*']
        'Foo': Foo\*Module\*Presenter
        'Foo:Bar': Bar\*Module\*Presenter

Presenter class mapping

You can define mapping between presenter name and class directly for individual presenters. This is especially useful when you need to override a single presenter from a module provided for example by external composer package.

Example:

application:
    mapping:
        'Foo:Bar:Baz': FooBar\BazPresenter

Configuration from another CompilerExtension

Some extensions may need to setup their own presenter mappings, this can be done in beforeCompile() phase by customizing setup of PresenterMapper.

$presenterMapper = $containerBuilder->getByType(Nepada\PresenterMapping\PresenterMapper::class);
$containerBuilder->getDefinition($presenterMapper)
    ->addSetup('setPresenterMapping', ['Foo:Bar:Baz', FooBar\BazPresenter::class])
    ->addSetup('setModuleMapping', ['Foo:Bar', 'Bar\*Module\*Presenter'])
    ->addSetup('setModuleMapping', ['Foo', 'Foo\*Module\*Presenter']);
  • v1.1.0 1.1.0

    • Requires Nette 2.4 and PHP 7.1.
    • Uses declare(strict_types = 1).
    • Uses scalar and return type hints.
    • Compatible with PHP 7.2.
  • v1.0.3 1.0.3

    • Code style improvements.
  • v1.0.2 1.0.2

    • PresenterMapper accepts array module mask.
  • v1.0.1 1.0.1

    • Fixed compatibility with nette/di 2.4.
  • v1.0.0 1.0.0

    • Initial release.

Is this addon outdated? Did you find an issue? Please report it.

Componette Componette admin@componette.com